/*
///////////////////////////////////////////////////////////////////////////////////////////////////
//shnQ kbcvO

//	FileName	IR.c
//	Version		1.00
//	MCU		R8C/25 type:R5F21258,clock:20MHz(XIN clock)
//	Work		
//-------------------------------------------------------------------------------------------------
//

//	2008/06/19	Ver1.00

//-------------------------------------------------------------------------------------------------
//ldln
//	kbc\vOłB
	str1,str2,str3,str4Œ`Ă镶݂ɕ\܂B
	
	@\:LCD

//-------------------------------------------------------------------------------------------------
*/

/*

̃\tgEFA̓t[EFAłB

̃\tgEFAɊւ鎿ɂ܂ẮA
T|[g̑ΏۊOƂȂ܂B

쌠͍쐬ł()kldqL̂Ƃ܂B

̃\tgEFAgpƂɂSĂ̑QɂāA
쐬͈؂̐ӔC𕉂Ȃ̂Ƃ܂B

̃\tgEFÄꕔ܂͑SĂ𖳒fœ]ڂ邱Ƃ
֎~܂BGȂǂ֏ЉE^̏ꍇ͘A肢v
܂B

  Copyright (C) Hokuto denshi Co,Ltd. 2008

*/

/*
/////////////////////////////////////////////////////////////////////////////////////////
//CN[ht@C錾

*/
#include "R8C25.h"

/*
/////////////////////////////////////////////////////////////////////////////////////////
//ϐ錾
*/
unsigned char xcursor,ycursor;


/*
/////////////////////////////////////////////////////////////////////////////////////////
//^錾
*/
#define VAL_LCD_ROW	16
#define VAL_LCD_COLUMN	2


/*
/////////////////////////////////////////////////////////////////////////////////////////
//}N錾
*/
#define DB4	P0.BIT.P_5
#define DB5	P0.BIT.P_7
#define DB6	P0.BIT.P_3
#define DB7	P6.BIT.P_4
#define RS	P6.BIT.P_2
#define E	P0.BIT.P_1

/*
/////////////////////////////////////////////////////////////////////////////////////////
//֐vg^Cv錾
*/
void port_init(void);
int LCD_init(void);
int LCD_clear(void);
int LCD_write(const unsigned char lcddata);
int LCD_location(const unsigned char x,const unsigned char y);
int LCD_print(const unsigned char *lcdstr);
void wait(const long msec);
void timer_interrupt(void);
void rx_str0(void);
void int0_func(void);
void int1_func(void);


/*
///////////////////////////////////////////////////////////////////////////////
//Main program
*/
void main(void){
	unsigned char data;
	const char *str1 = "޼ֳضĳ޻޲Ͻ";
	const char *str2 = "Tiny I/O 2\nDEMO PROGRAM";
	const char *str3 = "LCD DEMO PROGRAM(CPU:R8C/25)";
	const char *str4 = "clock:20MHz(XIN clock)";
	xcursor = 0;
	ycursor = 0;
	
	/*NbNݒ*/
	PRCR.BYTE = 0x01;		/*CM0,CM1,OCDɏ*/
	CM1.BIT.CM13 = 1;		/*XIN-XOUT [q*/
	CM0.BIT.CM05 = 0;		/*XINNbNU*/
	asm("NOP");			/*U莞Ԃ҂*/
	asm("NOP");
	asm("NOP");
	asm("NOP");
	OCD.BIT.OCD2 = 0;		/*XINNbNI*/
	
	port_init();
	LCD_init();
	LCD_clear();
	
	while(1){
		LCD_location(0,0);
		LCD_print(str1);
		wait(100);
		LCD_clear();
		LCD_location(0,0);
		LCD_print(str2);
		wait(100);
		LCD_clear();
		LCD_location(0,0);
		LCD_print(str3);
		wait(100);
		LCD_clear();
		LCD_location(0,0);
		LCD_print(str4);
		wait(200);
		LCD_clear();
	}
}


/*|[g*/
void port_init(void){
	/**********o̓|[g**********/
	PRCR.BIT.PRC2 = 1;		/*PD0ɏ*/
	PD0.BYTE = 0xFF;		/*gpȂs͏o͂ɐݒ*/
	PD1.BYTE = 0xFF;
	PD2.BYTE = 0xFF;
	PD3.BYTE = 0xB;
	PD4.BYTE = 0x3C;
	PD6.BYTE = 0xFF;
	
	P0.BYTE = 0x00;
	P1.BYTE = 0x00;
	P2.BYTE = 0xFF;
	P3.BYTE = 0x00;
	P4.BYTE = 0x00;
	P6.BYTE = 0x0A;
}



void wait(const long msec){
	volatile long i;
	for(i=0;i<200*msec;i++);
}

/* LCD֐ ///////////////////////////////////////////////////////////*/
/*********************************** LCD functions ***********************************/
/*LCD*/
int LCD_init(void){
	wait(20);
	RS = 0;
	/*LCD1*/
	E = 1;
	DB4 = 1;		/*MM1*/
	DB5 = 1;
	DB6 = 0;
	DB7 = 0;
	wait(1);
	E = 0;
	wait(1);
	wait(5);
	
	/*LCD2*/
	E = 1;
	DB4 = 1;		/*MM2*/
	DB5 = 1;
	DB6 = 0;
	DB7 = 0;
	wait(1);
	E = 0;
	wait(1);

	/*LCD3*/
	E = 1;
	DB4 = 1;		/*MM3*/
	DB5 = 1;
	DB6 = 0;
	DB7 = 0;
	wait(1);
	E = 0;
	wait(1);
	
	/*LCD4*/
	E = 1;
	DB4 = 0;		/*MM4*/
	DB5 = 1;
	DB6 = 0;
	DB7 = 0;
	wait(1);
	E = 0;
	wait(1);
	
	LCD_clear();
	
	/*t@NVZbg  4bit(DL=0),2s(N=0),5x7tHg(F=0)*/
	LCD_write(0x28/*0x20 + 0x08*/);

	/*Gg[[h  \VtgȂ(S=0),CNg(I/O=1)*/
	LCD_write(0x06/*0x04 + 0x02*/);

	/*J[\/\Vtg  J[\ړ(S/C=0),Vtg(R/L=0)*/
	LCD_write(0x10);

	/*\ON/OFFRg[  S\(D=1),J[\:ON(C=1),uN:ON(B=1)*/
	LCD_write(0x0D/*0x08 + 0x04 + 0x01*/);
	
	
	LCD_clear();
	wait(5);
	return 0;
}
/*\NA*/
int LCD_clear(void){
	RS = 0;
	LCD_write(0x01);
	wait(2);
	LCD_location(0,0);
	return 0;
}

/**/
int LCD_write(char lcddata){
	/*4bit*/
	E = 1;
	DB4 = (( lcddata >> 4 ) & 0x01);
	DB5 = (( lcddata >> 5 ) & 0x01);
	DB6 = (( lcddata >> 6 ) & 0x01);
	DB7 = (( lcddata >> 7 ) & 0x01);
	wait(1);
	E = 0;
	wait(1);
	/*4bit*/
	E = 1;
	DB4 = ( lcddata & 0x01);
	DB5 = (( lcddata >> 1 ) & 0x01);
	DB6 = (( lcddata >> 2 ) & 0x01);
	DB7 = (( lcddata >> 3 ) & 0x01);
	wait(1);
	E = 0;
	wait(1);
	return 0;
}

/*J[\ړ*/
int LCD_location(const unsigned char x,const unsigned char y){
	unsigned char addressdata;
	addressdata = ( (y * 0x40) + x );
	addressdata = (addressdata | 0x80);		/*DRAMAhXݒDB7͐M*/
	RS = 0;
	LCD_write(addressdata);
	wait(1);

	xcursor = x;					/*J[\ۑ*/
	ycursor = y;
	return 0;
}

/*\*/
int LCD_print(char far *lcdstr){
	unsigned char n=0,j;
	/* \[v */
	for(n=0; lcdstr[n] != '\0'; n++){
		/*`*/
		if((lcdstr[n] >= 0x20 && lcdstr[n] <= 0x7f) || (lcdstr[n] >= 0xa1 && lcdstr[n] <= 0xfd)){
			/*LCDR[h͈͓̔̏ꍇ*/
			/*`*/
			RS = 1;
			LCD_write(lcdstr[n]);
			wait(1);
				/*J[\ړ*/
				if(xcursor == (VAL_LCD_ROW - 1)){	/*16sI[o[ꍇ(15,0)1̂҂*/
					
					xcursor = 0;
					ycursor = (ycursor == 0 ? 1 : 0);	/*(0,1)珑*/
					LCD_location(xcursor,ycursor);
					for(j=0; j < VAL_LCD_ROW; ++j){
						RS = 1;
						LCD_write(' ');
					}
					LCD_location(xcursor,ycursor);
				}
				else{					/*16sȓ̏ꍇ*/
					++xcursor;
					LCD_location(xcursor,ycursor);
				}
		}
		else if( lcdstr[n] == '\n' ){			/*sR[h̏ꍇ*/
			xcursor = 0;
			ycursor = (ycursor == 0 ? 1 : 0);	/*y0*/
			LCD_location(xcursor,ycursor);
			for(j=0; j < 16; ++j){
				RS = 1;
				LCD_write(' ');
			}
			LCD_location(xcursor,ycursor);
		}
		else {	/*LCDR[h͈̔͊Ȍꍇ*/
		/* if ( ( lcdstr[n] >= 0x21 && lcdstr[n] <= 0x7f ) || ( lcdstr[n] >= 0xa1 && lcdstr[n] <= 0xfd ) )*/
		}
	}
	return 0;
}



#pragma INTERRUPT timer_interrupt
void timer_interrupt(void){
	;	/*dummy*/
}


#pragma INTERRUPT rx_str0
void rx_str0(void){
	;	/*dummy*/
}


#pragma INTERRUPT rx_str0
void int0_func(void){
	;	/*dummy*/
}


#pragma INTERRUPT rx_str0
void int1_func(void){
	;	/*dummy*/
}

